# Admin Module

import es, popuplib, cmdlib

dm = es.import_addon('dm')
delay = dm.delay


def load():
    cmdlib.registerSayCommand('!dmadmin', cmd_adminMenu, 'Deathmatch Admin Menu')
    dm.msg('Loaded Addon - Admin')
    
def unload():
    cmdlib.unregisterSayCommand('!dmadmin')
    dm.msg('Unloaded Addon - Admin')
    
def checkPop(p):
    if popuplib.exists(p): popuplib.delete(p)
    
def cmd_adminMenu(userid, args):
    if dm.isAuthed(userid):
        adminPop.send(userid)
    else:
        tell(userid, 'You don\'t have access')
        
def mainSelect(userid, choice, popupname):
    #checkPop(popupname)
    
    if choice == 1:
        genPlayerlistPop('dm_admin_select_player_%s'%userid, spawnSelect).send(userid)
    elif choice == 2:
        genPlayerlistPop('dm_admin_select_player_%s'%userid, teamSelect).send(userid)
        
    elif choice == 3:
        if dm.settings.gunmenu:
            dm.settings.gunmenu = 0
            dm.tell(userid, 'Disabled Guns menu')
        else:
            dm.settings.gunmenu = 1
            dm.tell(userid, 'Enabled Guns Menu')
            
        adminPop.send(userid)
        
    elif choice == 3:
        if dm.settings.noblock:
            dm.settings.noblock = 0
            dm.tell(userid, 'Disabled NoBlock')
        else:
            dm.settings.noblock = 1
            dm.tell(userid, 'Enabled NoBlock')
            
        adminPop.send(userid)
        
    elif choice == 5:
        change_respawn(userid)
        
def change_respawn(userid):
    if popuplib.exists('dm_admin_respawntypes'):
        popuplib.delete('dm_admin_respawntypes')
        
    p = popuplib.easymenu('dm_admin_respawntypes', None, select_respawn_type)
    p.settitle('Select Respawn Type')
    for root, dirs, files in os.walk(es.getAddonPath('dm/addons/respawntypes')):
        for dir in dirs:
            p.addoption(dir, dir)
            
    p.send(userid)
    
def select_respawn_type(userid, choice, popupname):
    if popuplib.exists(popupname):
        popuplib.delete(popupname)
        
    dm.respawntype = choice
    dm.tell(userid, 'Changed respawntype to %s'%choice)
    adminPop.send(userid)
        
        
def genPlayerlistPop(popupname, callback):
    p = popuplib.easymenu(popupname, None, callback)
    p.settitle('Select Player')
    for i in es.getUseridList():
        p.addoption(i, es.getplayername(i))
    return p
        
        
        
def spawnSelect(userid, choice, popupname):
    checkPop(popupname)
    if es.exists('userid', choice):
        dm.respawn(choice)
        dm.tell(userid, 'Respawned %s'%es.getplayername(choice))
    else:
        dm.tell(userid, 'Respawn Error - Cannot find player')
        
    mainSelect(userid, 1, None)
        
def teamSelect(userid, choice, popupname):
    checkPop(popupname)
    teamList = popuplib.easymenu('dm_admin_team_select_%s'%userid, None, team2Select)
    teamList.settitle('Select Team')
    teamList.addoption((choice, 2), 'Terrorist')
    teamList.addoption((choice, 3), 'Counter-Terrorist')
    teamList.addoption((choice, 1), 'Spectator')
    teamList.send(userid)
        
def team2Select(userid, choice, popupname):
    checkPop(popupname)
    puserid, team = choice
    if es.exists('userid', puserid):
        dm.changeTeam(userid, team)
        dm.tell(userid, 'Swapped %s\'s team'%es.getplayername(puserid))
    else:
        dm.tell(userid, 'Team Change Error - Cannot find player')
        
    mainSelect(userid, 2, None)
    
        
adminPop = popuplib.easymenu('dm_admin_main', None, mainSelect)
adminPop.settitle('Deathmatch Admin')
adminPop.addoption(1, 'Spawn Player')
adminPop.addoption(2, 'Set player team')
adminPop.addoption(5, 'Change Respawn type')
adminPop.addoption(3, 'Toggle Guns Menu')
adminPop.addoption(4, 'Toggle NoBlock')